diff --git a/src/main/java/org/distorted/objectlib/main/TwistyHexahedron.java b/src/main/java/org/distorted/objectlib/main/TwistyHexahedron.java
new file mode 100644
index 00000000..4c2a0daf
--- /dev/null
+++ b/src/main/java/org/distorted/objectlib/main/TwistyHexahedron.java
@@ -0,0 +1,83 @@
+///////////////////////////////////////////////////////////////////////////////////////////////////
+// Copyright 2019 Leszek Koltunski                                                               //
+//                                                                                               //
+// This file is part of Magic Cube.                                                              //
+//                                                                                               //
+// Magic Cube is free software: you can redistribute it and/or modify                            //
+// it under the terms of the GNU General Public License as published by                          //
+// the Free Software Foundation, either version 2 of the License, or                             //
+// (at your option) any later version.                                                           //
+//                                                                                               //
+// Magic Cube is distributed in the hope that it will be useful,                                 //
+// but WITHOUT ANY WARRANTY; without even the implied warranty of                                //
+// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the                                 //
+// GNU General Public License for more details.                                                  //
+//                                                                                               //
+// You should have received a copy of the GNU General Public License                             //
+// along with Magic Cube.  If not, see <http://www.gnu.org/licenses/>.                           //
+///////////////////////////////////////////////////////////////////////////////////////////////////
+
+package org.distorted.objectlib.main;
+
+import java.io.InputStream;
+
+import org.distorted.library.type.Static3D;
+import org.distorted.library.type.Static4D;
+
+///////////////////////////////////////////////////////////////////////////////////////////////////
+
+public abstract class TwistyHexahedron extends TwistyObject
+{
+  static final int[] FACE_COLORS = new int[]
+         {
+           COLOR_YELLOW, COLOR_WHITE,
+           COLOR_BLUE  , COLOR_GREEN,
+           COLOR_RED   , COLOR_ORANGE
+         };
+
+  static final int NUM_FACES = 6;
+  static final int FOV = 60;
+  static final float RATIO = 0.50f;
+
+///////////////////////////////////////////////////////////////////////////////////////////////////
+
+  public TwistyHexahedron(int[] numLayers, float realSize, Static4D quat, Static3D move, float scale, InputStream stream)
+    {
+    super(numLayers, realSize, quat, move, scale, stream);
+    }
+
+///////////////////////////////////////////////////////////////////////////////////////////////////
+
+  public final int getNumFaces()
+    {
+    return NUM_FACES;
+    }
+
+///////////////////////////////////////////////////////////////////////////////////////////////////
+
+  public int getNumFaceColors()
+    {
+    return FACE_COLORS.length;
+    }
+
+///////////////////////////////////////////////////////////////////////////////////////////////////
+
+  public int getColor(int face)
+    {
+    return FACE_COLORS[face];
+    }
+
+///////////////////////////////////////////////////////////////////////////////////////////////////
+
+  public int getFOV()
+    {
+    return FOV;
+    }
+
+///////////////////////////////////////////////////////////////////////////////////////////////////
+
+  public float getScreenRatio()
+    {
+    return RATIO;
+    }
+}
diff --git a/src/main/java/org/distorted/objectlib/main/TwistyJson.java b/src/main/java/org/distorted/objectlib/main/TwistyJson.java
index 07a1abaa..a184131c 100644
--- a/src/main/java/org/distorted/objectlib/main/TwistyJson.java
+++ b/src/main/java/org/distorted/objectlib/main/TwistyJson.java
@@ -286,10 +286,10 @@ public class TwistyJson extends TwistyObject
     {
     switch( mReader.getNumFaces() )
       {
-      case  4: return Twisty4.FOV;
-      case  6: return Twisty6.FOV;
-      case  8: return Twisty8.FOV;
-      case 12: return Twisty12.FOV;
+      case  4: return TwistyTetrahedron.FOV;
+      case  6: return TwistyHexahedron.FOV;
+      case  8: return TwistyOctahedron.FOV;
+      case 12: return TwistyDodecahedron.FOV;
       }
 
     return 0;
@@ -301,10 +301,10 @@ public class TwistyJson extends TwistyObject
     {
     switch( mReader.getNumFaces() )
       {
-      case  4: return Twisty4.RATIO;
-      case  6: return Twisty6.RATIO;
-      case  8: return Twisty8.RATIO;
-      case 12: return Twisty12.RATIO;
+      case  4: return TwistyTetrahedron.RATIO;
+      case  6: return TwistyHexahedron.RATIO;
+      case  8: return TwistyOctahedron.RATIO;
+      case 12: return TwistyDodecahedron.RATIO;
       }
 
     return 0.0f;
diff --git a/src/main/java/org/distorted/objectlib/main/TwistyObject.java b/src/main/java/org/distorted/objectlib/main/TwistyObject.java
index 34a87aeb..d0e204f8 100644
--- a/src/main/java/org/distorted/objectlib/main/TwistyObject.java
+++ b/src/main/java/org/distorted/objectlib/main/TwistyObject.java
@@ -1339,16 +1339,16 @@ public abstract class TwistyObject
 
       switch(movementType)
         {
-        case MOVEMENT_TETRAHEDRON : mMovement = new Movement4(mAxis,mCuts,mLayerRotatable,mSize,movementSplit,mEnabled);
+        case MOVEMENT_TETRAHEDRON : mMovement = new MovementTetrahedron(mAxis,mCuts,mLayerRotatable,mSize,movementSplit,mEnabled);
                                     break;
-        case MOVEMENT_HEXAHEDRON  : mMovement = new Movement6(mAxis,mCuts,mLayerRotatable,mSize,movementSplit,mEnabled);
+        case MOVEMENT_HEXAHEDRON  : mMovement = new MovementHexahedron(mAxis,mCuts,mLayerRotatable,mSize,movementSplit,mEnabled);
                                     break;
-        case MOVEMENT_OCTAHEDRON  : mMovement = new Movement8(mAxis,mCuts,mLayerRotatable,mSize,movementSplit,mEnabled);
+        case MOVEMENT_OCTAHEDRON  : mMovement = new MovementOctahedron(mAxis,mCuts,mLayerRotatable,mSize,movementSplit,mEnabled);
                                     break;
-        case MOVEMENT_DODECAHEDRON: mMovement = new Movement12(mAxis,mCuts,mLayerRotatable,mSize,movementSplit,mEnabled);
+        case MOVEMENT_DODECAHEDRON: mMovement = new MovementDodecahedron(mAxis,mCuts,mLayerRotatable,mSize,movementSplit,mEnabled);
                                     break;
         case MOVEMENT_SHAPECHANGE : float[] dist3D = getDist3D(numLayers);
-                                    mMovement = new MovementC(mAxis,mCuts,mLayerRotatable,mSize,movementSplit,mEnabled,dist3D);
+                                    mMovement = new MovementCuboids(mAxis,mCuts,mLayerRotatable,mSize,movementSplit,mEnabled,dist3D);
                                     break;
         }
       }
diff --git a/src/main/java/org/distorted/objectlib/main/TwistyOctahedron.java b/src/main/java/org/distorted/objectlib/main/TwistyOctahedron.java
new file mode 100644
index 00000000..049e1409
--- /dev/null
+++ b/src/main/java/org/distorted/objectlib/main/TwistyOctahedron.java
@@ -0,0 +1,84 @@
+///////////////////////////////////////////////////////////////////////////////////////////////////
+// Copyright 2019 Leszek Koltunski                                                               //
+//                                                                                               //
+// This file is part of Magic Cube.                                                              //
+//                                                                                               //
+// Magic Cube is free software: you can redistribute it and/or modify                            //
+// it under the terms of the GNU General Public License as published by                          //
+// the Free Software Foundation, either version 2 of the License, or                             //
+// (at your option) any later version.                                                           //
+//                                                                                               //
+// Magic Cube is distributed in the hope that it will be useful,                                 //
+// but WITHOUT ANY WARRANTY; without even the implied warranty of                                //
+// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the                                 //
+// GNU General Public License for more details.                                                  //
+//                                                                                               //
+// You should have received a copy of the GNU General Public License                             //
+// along with Magic Cube.  If not, see <http://www.gnu.org/licenses/>.                           //
+///////////////////////////////////////////////////////////////////////////////////////////////////
+
+package org.distorted.objectlib.main;
+
+import java.io.InputStream;
+
+import org.distorted.library.type.Static3D;
+import org.distorted.library.type.Static4D;
+
+///////////////////////////////////////////////////////////////////////////////////////////////////
+
+public abstract class TwistyOctahedron extends TwistyObject
+{
+  static final int[] FACE_COLORS = new int[]
+         {
+           COLOR_ORANGE, COLOR_VIOLET,
+           COLOR_WHITE , COLOR_BLUE  ,
+           COLOR_YELLOW, COLOR_RED   ,
+           COLOR_GREEN , COLOR_GREY
+         };
+
+  static final int NUM_FACES = 8;
+  static final int FOV = 60;
+  static final float RATIO = 0.68f;
+
+///////////////////////////////////////////////////////////////////////////////////////////////////
+
+  public TwistyOctahedron(int[] numLayers, float realSize, Static4D quat, Static3D move, float scale, InputStream stream)
+    {
+    super(numLayers, realSize, quat, move, scale, stream);
+    }
+
+///////////////////////////////////////////////////////////////////////////////////////////////////
+
+  public final int getNumFaces()
+    {
+    return NUM_FACES;
+    }
+
+///////////////////////////////////////////////////////////////////////////////////////////////////
+
+  public int getNumFaceColors()
+    {
+    return FACE_COLORS.length;
+    }
+
+///////////////////////////////////////////////////////////////////////////////////////////////////
+
+  public int getColor(int face)
+    {
+    return FACE_COLORS[face];
+    }
+
+///////////////////////////////////////////////////////////////////////////////////////////////////
+
+  public int getFOV()
+    {
+    return FOV;
+    }
+
+///////////////////////////////////////////////////////////////////////////////////////////////////
+
+  public float getScreenRatio()
+    {
+    return RATIO;
+    }
+}
diff --git a/src/main/java/org/distorted/objectlib/main/TwistyTetrahedron.java b/src/main/java/org/distorted/objectlib/main/TwistyTetrahedron.java
new file mode 100644
index 00000000..1f731b3b
--- /dev/null
+++ b/src/main/java/org/distorted/objectlib/main/TwistyTetrahedron.java
@@ -0,0 +1,82 @@
+///////////////////////////////////////////////////////////////////////////////////////////////////
+// Copyright 2019 Leszek Koltunski                                                               //
+//                                                                                               //
+// This file is part of Magic Cube.                                                              //
+//                                                                                               //
+// Magic Cube is free software: you can redistribute it and/or modify                            //
+// it under the terms of the GNU General Public License as published by                          //
+// the Free Software Foundation, either version 2 of the License, or                             //
+// (at your option) any later version.                                                           //
+//                                                                                               //
+// Magic Cube is distributed in the hope that it will be useful,                                 //
+// but WITHOUT ANY WARRANTY; without even the implied warranty of                                //
+// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the                                 //
+// GNU General Public License for more details.                                                  //
+//                                                                                               //
+// You should have received a copy of the GNU General Public License                             //
+// along with Magic Cube.  If not, see <http://www.gnu.org/licenses/>.                           //
+///////////////////////////////////////////////////////////////////////////////////////////////////
+
+package org.distorted.objectlib.main;
+
+import java.io.InputStream;
+
+import org.distorted.library.type.Static3D;
+import org.distorted.library.type.Static4D;
+
+///////////////////////////////////////////////////////////////////////////////////////////////////
+
+public abstract class TwistyTetrahedron extends TwistyObject
+{
+  static final int[] FACE_COLORS = new int[]
+         {
+           COLOR_GREEN , COLOR_YELLOW,
+           COLOR_BLUE  , COLOR_RED
+         };
+
+  static final int NUM_FACES = 4;
+  static final int FOV = 60;
+  static final float RATIO = 0.89f;
+
+///////////////////////////////////////////////////////////////////////////////////////////////////
+
+  public TwistyTetrahedron(int[] numLayers, float realSize, Static4D quat, Static3D move, float scale, InputStream stream)
+    {
+    super(numLayers, realSize, quat, move, scale, stream);
+    }
+
+///////////////////////////////////////////////////////////////////////////////////////////////////
+
+  public final int getNumFaces()
+    {
+    return NUM_FACES;
+    }
+
+///////////////////////////////////////////////////////////////////////////////////////////////////
+
+  public int getNumFaceColors()
+    {
+    return FACE_COLORS.length;
+    }
+
+///////////////////////////////////////////////////////////////////////////////////////////////////
+
+  public int getColor(int face)
+    {
+    return FACE_COLORS[face];
+    }
+
+///////////////////////////////////////////////////////////////////////////////////////////////////
+
+  public int getFOV()
+    {
+    return FOV;
+    }
+
+///////////////////////////////////////////////////////////////////////////////////////////////////
+
+  public float getScreenRatio()
+    {
+    return RATIO;
+    }
+}
diff --git a/src/main/java/org/distorted/objectlib/objects/TwistyBandagedAbstract.java b/src/main/java/org/distorted/objectlib/objects/TwistyBandagedAbstract.java
index a62db01f..bb5c34fc 100644
--- a/src/main/java/org/distorted/objectlib/objects/TwistyBandagedAbstract.java
+++ b/src/main/java/org/distorted/objectlib/objects/TwistyBandagedAbstract.java
@@ -27,16 +27,16 @@ import java.io.InputStream;
 import org.distorted.library.type.Static3D;
 import org.distorted.library.type.Static4D;
 
-import org.distorted.objectlib.main.Movement6;
+import org.distorted.objectlib.main.MovementHexahedron;
 import org.distorted.objectlib.helpers.ObjectShape;
 import org.distorted.objectlib.helpers.ObjectSticker;
 import org.distorted.objectlib.helpers.ScrambleState;
 import org.distorted.objectlib.main.ObjectControl;
-import org.distorted.objectlib.main.Twisty6;
+import org.distorted.objectlib.main.TwistyHexahedron;
 
 ///////////////////////////////////////////////////////////////////////////////////////////////////
 
-abstract class TwistyBandagedAbstract extends Twisty6
+abstract class TwistyBandagedAbstract extends TwistyHexahedron
 {
   // the three rotation axis of a 3x3 Cube. Must be normalized.
   static final Static3D[] ROT_AXIS = new Static3D[]
@@ -121,7 +121,7 @@ abstract class TwistyBandagedAbstract extends Twisty6
     {
     if( mQuats==null ) initializeQuats();
     int status = retCubitSolvedStatus(cubit,numLayers);
-    return status<0 ? null : buildSolvedQuats(Movement6.FACE_AXIS[status],mQuats);
+    return status<0 ? null : buildSolvedQuats(MovementHexahedron.FACE_AXIS[status],mQuats);
     }
 
 ///////////////////////////////////////////////////////////////////////////////////////////////////
diff --git a/src/main/java/org/distorted/objectlib/objects/TwistyCuboid.java b/src/main/java/org/distorted/objectlib/objects/TwistyCuboid.java
index ad09c35b..b8639fce 100644
--- a/src/main/java/org/distorted/objectlib/objects/TwistyCuboid.java
+++ b/src/main/java/org/distorted/objectlib/objects/TwistyCuboid.java
@@ -27,17 +27,17 @@ import java.io.InputStream;
 import org.distorted.library.type.Static3D;
 import org.distorted.library.type.Static4D;
 
-import org.distorted.objectlib.main.MovementC;
+import org.distorted.objectlib.main.MovementCuboids;
 import org.distorted.objectlib.main.ObjectControl;
 import org.distorted.objectlib.main.ObjectType;
 import org.distorted.objectlib.helpers.ObjectShape;
 import org.distorted.objectlib.helpers.ObjectSticker;
 import org.distorted.objectlib.helpers.ScrambleState;
-import org.distorted.objectlib.main.Twisty6;
+import org.distorted.objectlib.main.TwistyHexahedron;
 
 ///////////////////////////////////////////////////////////////////////////////////////////////////
 
-public class TwistyCuboid extends Twisty6
+public class TwistyCuboid extends TwistyHexahedron
 {
   static final Static3D[] ROT_AXIS = new Static3D[]
          {
@@ -210,7 +210,7 @@ public class TwistyCuboid extends Twisty6
     {
     if( mQuats ==null ) initializeQuats();
     int status = retCubitSolvedStatus(cubit,numLayers);
-    return status<0 ? null : buildSolvedQuats(MovementC.FACE_AXIS[status], mQuats);
+    return status<0 ? null : buildSolvedQuats(MovementCuboids.FACE_AXIS[status], mQuats);
     }
 
 ///////////////////////////////////////////////////////////////////////////////////////////////////
diff --git a/src/main/java/org/distorted/objectlib/objects/TwistyDiamond.java b/src/main/java/org/distorted/objectlib/objects/TwistyDiamond.java
index 17ef788e..f8299012 100644
--- a/src/main/java/org/distorted/objectlib/objects/TwistyDiamond.java
+++ b/src/main/java/org/distorted/objectlib/objects/TwistyDiamond.java
@@ -27,17 +27,17 @@ import java.io.InputStream;
 import org.distorted.library.type.Static3D;
 import org.distorted.library.type.Static4D;
 
-import org.distorted.objectlib.main.Movement8;
+import org.distorted.objectlib.main.MovementOctahedron;
 import org.distorted.objectlib.main.ObjectControl;
 import org.distorted.objectlib.main.ObjectType;
 import org.distorted.objectlib.helpers.ObjectShape;
 import org.distorted.objectlib.helpers.ObjectSticker;
 import org.distorted.objectlib.helpers.ScrambleState;
-import org.distorted.objectlib.main.Twisty8;
+import org.distorted.objectlib.main.TwistyOctahedron;
 
 ///////////////////////////////////////////////////////////////////////////////////////////////////
 
-public class TwistyDiamond extends Twisty8
+public class TwistyDiamond extends TwistyOctahedron
 {
   // the four rotation axis of a Diamond. Must be normalized.
   static final Static3D[] ROT_AXIS = new Static3D[]
@@ -118,7 +118,7 @@ public class TwistyDiamond extends Twisty8
     if( mQuats==null ) initializeQuats();
     if( mFaceMap==null ) mFaceMap = new int[] {4,0,6,2,7,3,5,1};
     int status = retCubitSolvedStatus(cubit,numLayers);
-    return status<0 ? null : buildSolvedQuats(Movement8.FACE_AXIS[mFaceMap[status]],mQuats);
+    return status<0 ? null : buildSolvedQuats(MovementOctahedron.FACE_AXIS[mFaceMap[status]],mQuats);
     }
 
 ///////////////////////////////////////////////////////////////////////////////////////////////////
diff --git a/src/main/java/org/distorted/objectlib/objects/TwistyDino.java b/src/main/java/org/distorted/objectlib/objects/TwistyDino.java
index 553cf6aa..094c53f4 100644
--- a/src/main/java/org/distorted/objectlib/objects/TwistyDino.java
+++ b/src/main/java/org/distorted/objectlib/objects/TwistyDino.java
@@ -31,11 +31,11 @@ import org.distorted.objectlib.helpers.ObjectShape;
 import org.distorted.objectlib.helpers.ObjectSticker;
 import org.distorted.objectlib.helpers.ScrambleState;
 import org.distorted.objectlib.main.ObjectControl;
-import org.distorted.objectlib.main.Twisty6;
+import org.distorted.objectlib.main.TwistyHexahedron;
 
 ///////////////////////////////////////////////////////////////////////////////////////////////////
 
-abstract class TwistyDino extends Twisty6
+abstract class TwistyDino extends TwistyHexahedron
 {
   // the four rotation axis of a RubikDino. Must be normalized.
   static final Static3D[] ROT_AXIS = new Static3D[]
diff --git a/src/main/java/org/distorted/objectlib/objects/TwistyHelicopter.java b/src/main/java/org/distorted/objectlib/objects/TwistyHelicopter.java
index c1e07bbb..00bcef2b 100644
--- a/src/main/java/org/distorted/objectlib/objects/TwistyHelicopter.java
+++ b/src/main/java/org/distorted/objectlib/objects/TwistyHelicopter.java
@@ -27,17 +27,17 @@ import java.io.InputStream;
 import org.distorted.library.type.Static3D;
 import org.distorted.library.type.Static4D;
 
-import org.distorted.objectlib.main.Movement6;
+import org.distorted.objectlib.main.MovementHexahedron;
 import org.distorted.objectlib.main.ObjectControl;
 import org.distorted.objectlib.main.ObjectType;
 import org.distorted.objectlib.helpers.ObjectShape;
 import org.distorted.objectlib.helpers.ObjectSticker;
 import org.distorted.objectlib.helpers.ScrambleState;
-import org.distorted.objectlib.main.Twisty6;
+import org.distorted.objectlib.main.TwistyHexahedron;
 
 ///////////////////////////////////////////////////////////////////////////////////////////////////
 
-public class TwistyHelicopter extends Twisty6
+public class TwistyHelicopter extends TwistyHexahedron
 {
   // the six rotation axis of a Helicopter. Must be normalized.
   static final Static3D[] ROT_AXIS = new Static3D[]
@@ -134,7 +134,7 @@ public class TwistyHelicopter extends Twisty6
     {
     if( mQuats==null ) initializeQuats();
     int status = retCubitSolvedStatus(cubit,numLayers);
-    return status<0 ? null : buildSolvedQuats(Movement6.FACE_AXIS[status],mQuats);
+    return status<0 ? null : buildSolvedQuats(MovementHexahedron.FACE_AXIS[status],mQuats);
     }
 
 ///////////////////////////////////////////////////////////////////////////////////////////////////
diff --git a/src/main/java/org/distorted/objectlib/objects/TwistyIvy.java b/src/main/java/org/distorted/objectlib/objects/TwistyIvy.java
index 9598aaf1..369b6a83 100644
--- a/src/main/java/org/distorted/objectlib/objects/TwistyIvy.java
+++ b/src/main/java/org/distorted/objectlib/objects/TwistyIvy.java
@@ -27,17 +27,17 @@ import java.io.InputStream;
 import org.distorted.library.type.Static3D;
 import org.distorted.library.type.Static4D;
 
-import org.distorted.objectlib.main.Movement6;
+import org.distorted.objectlib.main.MovementHexahedron;
 import org.distorted.objectlib.main.ObjectControl;
 import org.distorted.objectlib.main.ObjectType;
 import org.distorted.objectlib.helpers.ObjectShape;
 import org.distorted.objectlib.helpers.ObjectSticker;
 import org.distorted.objectlib.helpers.ScrambleState;
-import org.distorted.objectlib.main.Twisty6;
+import org.distorted.objectlib.main.TwistyHexahedron;
 
 ///////////////////////////////////////////////////////////////////////////////////////////////////
 
-public class TwistyIvy extends Twisty6
+public class TwistyIvy extends TwistyHexahedron
 {
   static final Static3D[] ROT_AXIS = new Static3D[]
          {
@@ -110,7 +110,7 @@ public class TwistyIvy extends Twisty6
     {
     if( mQuats==null ) initializeQuats();
     int status = retCubitSolvedStatus(cubit,numLayers);
-    return status<0 ? null : buildSolvedQuats(Movement6.FACE_AXIS[status],mQuats);
+    return status<0 ? null : buildSolvedQuats(MovementHexahedron.FACE_AXIS[status],mQuats);
     }
 
 ///////////////////////////////////////////////////////////////////////////////////////////////////
diff --git a/src/main/java/org/distorted/objectlib/objects/TwistyJing.java b/src/main/java/org/distorted/objectlib/objects/TwistyJing.java
index fe4b5980..acdb345a 100644
--- a/src/main/java/org/distorted/objectlib/objects/TwistyJing.java
+++ b/src/main/java/org/distorted/objectlib/objects/TwistyJing.java
@@ -27,17 +27,17 @@ import java.io.InputStream;
 import org.distorted.library.type.Static3D;
 import org.distorted.library.type.Static4D;
 
-import org.distorted.objectlib.main.Movement4;
+import org.distorted.objectlib.main.MovementTetrahedron;
 import org.distorted.objectlib.main.ObjectControl;
 import org.distorted.objectlib.main.ObjectType;
 import org.distorted.objectlib.helpers.ObjectShape;
 import org.distorted.objectlib.helpers.ObjectSticker;
 import org.distorted.objectlib.helpers.ScrambleState;
-import org.distorted.objectlib.main.Twisty4;
+import org.distorted.objectlib.main.TwistyTetrahedron;
 
 ///////////////////////////////////////////////////////////////////////////////////////////////////
 
-public class TwistyJing extends Twisty4
+public class TwistyJing extends TwistyTetrahedron
 {
   static final Static3D[] ROT_AXIS = new Static3D[]
          {
@@ -111,7 +111,7 @@ public class TwistyJing extends Twisty4
     {
     if( mQuats==null ) initializeQuats();
     int status = retCubitSolvedStatus(cubit,numLayers);
-    return status<0 ? null : buildSolvedQuats(Movement4.FACE_AXIS[status],mQuats);
+    return status<0 ? null : buildSolvedQuats(MovementTetrahedron.FACE_AXIS[status],mQuats);
     }
 
 ///////////////////////////////////////////////////////////////////////////////////////////////////
diff --git a/src/main/java/org/distorted/objectlib/objects/TwistyKilominx.java b/src/main/java/org/distorted/objectlib/objects/TwistyKilominx.java
index 53c1a0fb..99f3102a 100644
--- a/src/main/java/org/distorted/objectlib/objects/TwistyKilominx.java
+++ b/src/main/java/org/distorted/objectlib/objects/TwistyKilominx.java
@@ -19,8 +19,8 @@
 
 package org.distorted.objectlib.objects;
 
-import static org.distorted.objectlib.main.Movement12.COS54;
-import static org.distorted.objectlib.main.Movement12.SIN54;
+import static org.distorted.objectlib.main.MovementDodecahedron.COS54;
+import static org.distorted.objectlib.main.MovementDodecahedron.SIN54;
 
 import java.io.InputStream;
 
diff --git a/src/main/java/org/distorted/objectlib/objects/TwistyMegaminx.java b/src/main/java/org/distorted/objectlib/objects/TwistyMegaminx.java
index ba5dfaa9..6b0c8b3f 100644
--- a/src/main/java/org/distorted/objectlib/objects/TwistyMegaminx.java
+++ b/src/main/java/org/distorted/objectlib/objects/TwistyMegaminx.java
@@ -19,8 +19,8 @@
 
 package org.distorted.objectlib.objects;
 
-import static org.distorted.objectlib.main.Movement12.COS54;
-import static org.distorted.objectlib.main.Movement12.SIN54;
+import static org.distorted.objectlib.main.MovementDodecahedron.COS54;
+import static org.distorted.objectlib.main.MovementDodecahedron.SIN54;
 
 import java.io.InputStream;
 
diff --git a/src/main/java/org/distorted/objectlib/objects/TwistyMinx.java b/src/main/java/org/distorted/objectlib/objects/TwistyMinx.java
index af311356..dc73815a 100644
--- a/src/main/java/org/distorted/objectlib/objects/TwistyMinx.java
+++ b/src/main/java/org/distorted/objectlib/objects/TwistyMinx.java
@@ -21,22 +21,22 @@ package org.distorted.objectlib.objects;
 
 import static org.distorted.objectlib.main.Movement.MOVEMENT_DODECAHEDRON;
 import static org.distorted.objectlib.main.Movement.TYPE_SPLIT_EDGE;
-import static org.distorted.objectlib.main.Movement12.C2;
-import static org.distorted.objectlib.main.Movement12.LEN;
-import static org.distorted.objectlib.main.Movement12.SIN54;
+import static org.distorted.objectlib.main.MovementDodecahedron.C2;
+import static org.distorted.objectlib.main.MovementDodecahedron.LEN;
+import static org.distorted.objectlib.main.MovementDodecahedron.SIN54;
 
 import java.io.InputStream;
 
 import org.distorted.library.type.Static3D;
 import org.distorted.library.type.Static4D;
-import org.distorted.objectlib.main.Movement12;
+import org.distorted.objectlib.main.MovementDodecahedron;
 import org.distorted.objectlib.helpers.ObjectSticker;
 import org.distorted.objectlib.helpers.ScrambleState;
-import org.distorted.objectlib.main.Twisty12;
+import org.distorted.objectlib.main.TwistyDodecahedron;
 
 ///////////////////////////////////////////////////////////////////////////////////////////////////
 
-abstract class TwistyMinx extends Twisty12
+abstract class TwistyMinx extends TwistyDodecahedron
 {
   static final int NUM_CORNERS = 20;
   static final int NUM_CENTERS = 12;
@@ -494,7 +494,7 @@ abstract class TwistyMinx extends Twisty12
     if( mQuats==null ) initializeQuats();
     if( mFaceMap==null ) mFaceMap = new int[] {8,10,3,7,1,9,11,2,4,0,5,6};
     int status = retCubitSolvedStatus(cubit,numLayers);
-    return status<0 ? null : buildSolvedQuats(Movement12.FACE_AXIS[mFaceMap[status]],mQuats);
+    return status<0 ? null : buildSolvedQuats(MovementDodecahedron.FACE_AXIS[mFaceMap[status]],mQuats);
     }
 
 ///////////////////////////////////////////////////////////////////////////////////////////////////
@@ -512,7 +512,7 @@ abstract class TwistyMinx extends Twisty12
     if( mCuts==null )
       {
       mCuts = new float[6][numLayers-1];
-      float D = numLayers*Movement12.DIST3D;
+      float D = numLayers* MovementDodecahedron.DIST3D;
       float X = 2*D/(2+SIN18);  // height of the 'upper' part of a dodecahedron, i.e. put it on a table,
                                 // its height is then 2D, it has one 'lower' part of height X, one
                                 // 'middle' part of height Y and one upper part of height X again.
diff --git a/src/main/java/org/distorted/objectlib/objects/TwistyMirror.java b/src/main/java/org/distorted/objectlib/objects/TwistyMirror.java
index 5a305670..67f0e752 100644
--- a/src/main/java/org/distorted/objectlib/objects/TwistyMirror.java
+++ b/src/main/java/org/distorted/objectlib/objects/TwistyMirror.java
@@ -32,11 +32,11 @@ import org.distorted.objectlib.main.ObjectType;
 import org.distorted.objectlib.helpers.ObjectShape;
 import org.distorted.objectlib.helpers.ObjectSticker;
 import org.distorted.objectlib.helpers.ScrambleState;
-import org.distorted.objectlib.main.Twisty6;
+import org.distorted.objectlib.main.TwistyHexahedron;
 
 ///////////////////////////////////////////////////////////////////////////////////////////////////
 
-public class TwistyMirror extends Twisty6
+public class TwistyMirror extends TwistyHexahedron
 {
   static final Static3D[] ROT_AXIS = new Static3D[]
          {
